#ifndef GP2X_H
#define GP2X_H
/*
 * Copyright (C) 2006-2008 Vin Helminen 
 * $Id: gp2x.h,v 1.1.1.1 2008-07-23 23:30:02 vah Exp $
 */
#ifdef GP2X


#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>

static volatile unsigned long *gp2x_memregl = 0;
static volatile unsigned short *gp2x_memregs = 0;

static void GP2XQuit(void)
{
  if(gp2x_memregl) munmap((void*)gp2x_memregl, 0x10000);
  chdir("/usr/gp2x");
  execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
}

static inline void GP2XInit(void)
{
  int fd;

  if(atexit(GP2XQuit))
    GP2XQuit(); /* Function registration failed. Exit now, so that GP2X doesn't "hang". */

  fd = open("/dev/mem", O_RDWR);
  if(fd == -1) {
    perror("Open /dev/mem: ");
    exit(EXIT_FAILURE);
  }
  gp2x_memregl=mmap(0, 0x10000, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0xc0000000);
  gp2x_memregs=(void*)gp2x_memregl;
  close(fd);
}

static inline void GP2XWaitVBlank(void)
{
  gp2x_memregs[0x2846>>1]=(gp2x_memregs[0x2846>>1] | 0x20) & ~2;
  while(gp2x_memregs[0x1182>>1]&(1<<4));
  while(!(gp2x_memregs[0x1182>>1]&(1<<4)));
}


#endif

#endif
