#ifndef MYERROR_H
#define MYERROR_H

#include <stdlib.h>
#include <errno.h>
#include <error.h> // GNU extensions
#include <SDL/SDL.h>

#define ERROR(status, message) (error_at_line(status, errno, __FILE__, __LINE__, message),0)

#define CHECK_ERROR(p, status, message) (p || ERROR(status, message))

#define CHECK_SDL_ERROR(p) CHECK_ERROR(p, EXIT_FAILURE, SDL_GetError())

#define CHECK_MALLOC(p) CHECK_ERROR(p, EXIT_FAILURE, (SDL_Error(SDL_ENOMEM), SDL_GetError()))

#define CHECK_SANITY(p) CHECK_ERROR(p, 255, "WTF");


#endif
