#ifndef SYSCONF_H
#define SYSCONF_H

#define SCREEN_WIDTH  320
#define SCREEN_HEIGHT 240
#define SAMPLE_RATE   44100
#define AUDIO_BUFFER_SIZE   1024
#define MIX_CHANNELS  2

#ifdef GP2X

/* Video */
#define SCREEN_BPP 16     /* 8 or 16 for GP2X */
#define START_FULLSCREEN true

/* SDL joystick button codes */
#define GP2X_BUTTON_UP              0
#define GP2X_BUTTON_UPLEFT          1
#define GP2X_BUTTON_LEFT            2
#define GP2X_BUTTON_DOWNLEFT        3
#define GP2X_BUTTON_DOWN            4
#define GP2X_BUTTON_DOWNRIGHT       5
#define GP2X_BUTTON_RIGHT           6
#define GP2X_BUTTON_UPRIGHT         7
#define GP2X_BUTTON_START           8
#define GP2X_BUTTON_SELECT          9
#define GP2X_BUTTON_L               10
#define GP2X_BUTTON_R               11
#define GP2X_BUTTON_A               12
#define GP2X_BUTTON_B               13
#define GP2X_BUTTON_X               14
#define GP2X_BUTTON_Y               15
#define GP2X_BUTTON_VOLUP           16
#define GP2X_BUTTON_VOLDOWN         17
#define GP2X_BUTTON_CLICK           18

#else

#if 0
/* This is here just as a reminder. This should be set in Makefile similarly to the GP2X macro. */
/* The default location is along the executable. */
#define DATA_PATH /usr/share/
#endif

/* Video */
#define SCREEN_BPP 32   /* 8, 16 or 32 */
#define START_FULLSCREEN false

#endif

#endif
